"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@yarnpkg/core");
const algoliasearch_1 = __importDefault(require("algoliasearch"));
// Note that the appId and appKey are specific to Yarn's plugin-typescript - please
// don't use them anywhere else without asking Algolia's permission
const ALGOLIA_API_KEY = `e8e1bd300d860104bb8c58453ffa1eb4`;
const ALGOLIA_APP_ID = `OFCNCOG2CU`;
exports.hasDefinitelyTyped = async (descriptor, configuration) => {
    var _a;
    const stringifiedIdent = core_1.structUtils.stringifyIdent(descriptor);
    const algoliaClient = createAlgoliaClient(configuration);
    const index = algoliaClient.initIndex(`npm-search`);
    try {
        const packageInfo = await index.getObject(stringifiedIdent, { attributesToRetrieve: [`types`] });
        return ((_a = packageInfo.types) === null || _a === void 0 ? void 0 : _a.ts) === `definitely-typed`;
    }
    catch (_e) {
        return false;
    }
};
const createAlgoliaClient = (configuration) => {
    const requester = {
        async send(request) {
            try {
                const response = await core_1.httpUtils.request(request.url, request.data || null, {
                    configuration,
                    headers: request.headers,
                });
                return {
                    content: response.body,
                    isTimedOut: false,
                    status: response.statusCode,
                };
            }
            catch (error) {
                return {
                    content: error.response.body,
                    isTimedOut: false,
                    status: error.response.statusCode,
                };
            }
        }
    };
    return algoliasearch_1.default(ALGOLIA_APP_ID, ALGOLIA_API_KEY, { requester });
};
